function TGoogleMap()
{
    var map = null;
    var smallMapControl = null;
    var smallZoomControl= null;

    this.CreateMap = CreateMap;
    this.Render = Render;
    this.FindGeoCode = FindGeoCode;
    this.AddMarker = AddMarker;
    this.OpenInfoWindow = OpenInfoWindow;
    this.CloseInfoWindow = CloseInfoWindow;
    this.AddSmallMapControl = AddSmallMapControl;
    this.AddSmallZoomControl = AddSmallZoomControl;
    this.RemoveSmallMapControl = RemoveSmallMapControl;
    this.RemoveSmallZoomControl = RemoveSmallZoomControl;
    this.GotoCoordinat = GotoCoordinat;



    function CreateMap()
    {
        map = new GMap2(document.getElementById("Canvas"));

        GEvent.addListener(map, "click", function(overlay, point, overlaypoint) { external.DoClick(point.lat(), point.lng()); } );
    }

    function Render(lat, lng)
    {
        map.setCenter(new GLatLng(lat, lng), 13);
    }

    function FindGeoCode(address)
    {
        var geoCoder = new GClientGeocoder();
        geoCoder.getLatLng(address,
                                    function(point)
                                    {
                                        if (!point) { external.DoError("Belirtilen adres bulunamad.!"); }
                                        else
                                        {
                                            external.DoGeoCodeFound(point.lat(), point.lng());
                                        }
                                    }
                           );
    }

    function AddMarker(lat, lng, draggable)
    {
        var marker;

        if (draggable)
        {
            marker = new GMarker(new GLatLng(lat, lng), {draggable: true});
        }
        else
        {
            marker = new GMarker(new GLatLng(lat, lng), {draggable: false});
        }

        map.addOverlay(marker);
        GEvent.addListener(marker, "click", function()
            {
                var coord = marker.getLatLng();
                if (coord)
                    external.DoMarkerClick(coord.lat(), coord.lng());
            } );
    }


    function OpenInfoWindow(lat, lng, message)
    {
        map.openInfoWindow(new GLatLng(lat, lng),
                           document.createTextNode(message));

    }

    function CloseInfoWindow()
    {
        map.closeInfoWindow();
    }

    function AddSmallMapControl()
    {
        if (!smallMapControl)
        {
            smallMapControl = new GSmallMapControl();
            map.addControl(smallMapControl);
        }
    }

    function AddSmallZoomControl()
    {
        if (!smallZoomControl)
        {
            smallZoomControl = new GSmallZoomControl();
            map.addControl(smallZoomControl);
        }
    }

    function RemoveSmallMapControl()
    {
        if (smallMapControl)
        {
            map.removeControl(smallMapControl);
            smallMapControl = null;
        }
    }

    function RemoveSmallZoomControl()
    {
        if (smallZoomControl)
        {
            map.removeControl(smallZoomControl);
            smallZoomControl = null;
        }
    }

    function GotoCoordinat(lat, lng)
    {
        map.panTo(new GLatLng(lat, lng));
    }

}

var GoogleMap = new TGoogleMap();